// ENGBASE.H : a base class for computation engine classes.

// Copyright (C) 1998 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

////////////////////////////////////////////////////////////////////////////////////////////////////

#include "config.h"	// this is target-dependent...

#ifndef ENGBASE_H
#define ENGBASE_H

class bs_eng;

////////////////////////////////////////////////////////////////////////////////////////////////////

#include "typedef.h"

////////////////////////////////////////////////////////////////////////////////////////////////////

// for qm2- and mm1-models, it would be possible to make well-defined functions to pass
// coordinate data in and out; for example GetCRD() and PutCRD(). but it's not a good idea
// to make this too specific, since there may be reduced protein models etc which might not
// have clearly defined "atoms" at all... make an "all atoms"-middle class ?!?!?!?

class bs_eng
{
	private:
	
// this is just an interface definition -> there is no relevant common data?!?!?
// this is just an interface definition -> there is no relevant common data?!?!?
// this is just an interface definition -> there is no relevant common data?!?!?

	public:
	
	bs_eng(void);
	virtual ~bs_eng(void);
	
	virtual void Compute(i32s) = 0;
	virtual void Check(i32s) = 0;
	
	void Balance(i32s, i32s *, i32s *, i32s &, i32s);	// does it work?!?!?!
};

////////////////////////////////////////////////////////////////////////////////////////////////////

#endif	// ENGBASE_H

// eof
