// QM2MDL.H : joku lyhyt kuvaus sitten thn...

// Copyright (C) 2000 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

////////////////////////////////////////////////////////////////////////////////////////////////////

#include "config.h"	// this is target-dependent...

#ifndef QM2MDL_H
#define QM2MDL_H

class qm2_mdl;

////////////////////////////////////////////////////////////////////////////////////////////////////

#include "mdlbase.h"

#include "qm2eng.h"
#include "utility.h"

#include <list>
#include <vector>

////////////////////////////////////////////////////////////////////////////////////////////////////

class qm2_atom
{
	public:
	
	element el;
	vector<a3_fGL> crd_vector;
	
	public:
	
	qm2_atom(void);
	qm2_atom(element, fGL *, i32u);
	qm2_atom(const qm2_atom &);
	~qm2_atom(void);
	
	bool operator==(const qm2_atom &) const;	// using pointers...
};

typedef list<qm2_atom>::iterator iter_qm2al;		// al = atom list

class qm2_mdl : public bs_mdl_extended
{
	protected:
	
	public:
	
	list<qm2_atom> atom_list;
	
	qm2_eng * current_eng;
	i32s current_orbital;
	
	public:
	
	qm2_mdl(ostream *);
	~qm2_mdl(void);
	
	const char * GetProjectFileNameExtension(void);		// virtual
	
	virtual void DiscardCurrentEng(void);
	
	void PushCRDSets(i32u);			// virtual
	void PopCRDSets(i32u);			// virtual
	
	void CopyCRDSet(i32u, i32u);		// virtual
	void SwapCRDSets(i32u, i32u);		// virtual
	
	void CenterCRDSet(i32u);		// virtual
	void ReserveCRDSets(i32u);		// virtual
	
	void AddAtom(qm2_atom &);
	void RemoveAtom(iter_qm2al);
	
	void ImportMM1(const char *);
};

////////////////////////////////////////////////////////////////////////////////////////////////////

#endif	// QM2MDL_H

// eof
