// QM2GUI.H : a graphical user interface for qm2-models.

// Copyright (C) 2000 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

////////////////////////////////////////////////////////////////////////////////////////////////////

#include "config.h"	// this is target-dependent...

#ifndef QM2GUI_H
#define QM2GUI_H

#ifdef ENABLE_GUI

class qm2_gui;

class qm2_cm_element;		// mm1_atom *

////////////////////////////////////////////////////////////////////////////////////////////////////

#include "guibase.h"
#include "qm2mdl.h"

////////////////////////////////////////////////////////////////////////////////////////////////////

class qm2_gui : public bs_gui, public qm2_mdl
{
	public:
	
	static qm2_cm_element cm_element;
	
	qm2_atom * draw_data[2];
	
	public:
	
	qm2_gui(window_factory &, ostream *);
	virtual ~qm2_gui(void);
	
	void DiscardCurrentEng(void);		// virtual
	
	const char * GetType(void);			// virtual
	color_mode * GetDefaultColorMode(void);		// virtual
	
	void SelectAll(void);				// virtual
	void InvertSelection(void);			// virtual
	
	void InitGL(void);				// virtual
	void Render(view_window *, rmode);		// virtual
	
	void Center(transformer *);			// virtual
	void Transform(transformer *);			// virtual
	
	void DrawEvent(view_window *, vector<iGLu> &);		// virtual
	void EraseEvent(view_window *, vector<iGLu> &);		// virtual
	void SelectEvent(view_window *, vector<iGLu> &);	// virtual
	
	void DoEnergy(void);
	virtual void EnergyReport(qm2_eng *) = 0;
};

////////////////////////////////////////////////////////////////////////////////////////////////////

class qm2_cm_element : public color_mode
{
	protected:
	
	public:
	
	qm2_cm_element(void) : color_mode() { }
	~qm2_cm_element(void) { }
	
	void GetColor(const void *, fGL_a3 &);
};

////////////////////////////////////////////////////////////////////////////////////////////////////

#endif	// ENABLE_GUI
#endif	// QM2GUI_H

// eof
