// T2MAIN.CPP

// Copyright (C) 1998 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

////////////////////////////////////////////////////////////////////////////////////////////////////

#include "t2main.h"
#include "notice.h"

////////////////////////////////////////////////////////////////////////////////////////////////////

#define MODEL_QM1	0x0101
#define MODEL_QM2	0x0102

#define MODEL_MM1	0x0201

int main(int argc, char ** argv)
{
	print_full_copyright_notice(cout);
	
	i32s mtype = MODEL_MM1;
	
	// add "double-buffer"-flag to the command line!??!?!?!
	// add "stereo"-flag to the command line (once it works in OGL/Mesa)!??!?!?!
	
	for (i32s n1 = 1;n1 < argc;n1++)
	{
		if (!strcmp(argv[n1], "-h") || !strcmp(argv[n1], "--help"))
		{
			cout << "command-line options:" << endl;
			cout << "---------------------" << endl;
			cout << endl;
			cout << "-m, --model : select the model" << endl;
			cout << "   q1 -> QM, atomic calculations" << endl;
			cout << "   q2 -> QM, molecular calculations" << endl;
			cout << "   m1 -> MM, \"all atoms\"-model (this is the default)" << endl;
			cout << endl;
			
			cout << "command-line help ???" << endl;
			return 0;
		}
		
		if ((!strcmp(argv[n1], "-m") || !strcmp(argv[n1], "--model")) && (++n1 < argc))
		{
			if (!strcmp(argv[n1], "q1")) mtype = MODEL_QM1;
			if (!strcmp(argv[n1], "q2")) mtype = MODEL_QM2;
			if (!strcmp(argv[n1], "m1")) mtype = MODEL_MM1;
		}
	}
	
	glutInit(& argc, argv);
	glutInitWindowPosition(10, 10);
	glutInitWindowSize(400, 400);
	
	glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_ACCUM | GLUT_DOUBLE);
	
	bs_gui * gui = NULL;
	
	switch (mtype)
	{
		case MODEL_QM1:
		gui = new t2_qm1_gui(* glut_factory::GetInstance(), & cout);
		gui->AddCamera(1.0);
		break;
		
		case MODEL_QM2:
		gui = new t2_qm2_gui(* glut_factory::GetInstance(), & cout);
		gui->AddCamera(2.0);
		break;
		
		case MODEL_MM1:
		gui = new t2_mm1_gui(* glut_factory::GetInstance(), & cout);
		gui->AddCamera(2.0);
		break;
		
		default:
		cout << "something went wrong..." << endl;
		return 0;
	}
	
	cout << "model type is " << gui->GetType() << endl;
	cout << "press 'h' for help..." << endl;
	
	glutMainLoop();		// there is no return from this loop...
}

////////////////////////////////////////////////////////////////////////////////////////////////////

// eof
