// T3MM1GUI.H : a graphical user interface for mm1-models.

// Copyright (C) 1998 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

////////////////////////////////////////////////////////////////////////////////////////////////////

#include "config.h"	// this is target-dependent...

#ifndef T3MM1GUI_H
#define T3MM1GUI_H

class t3_mm1_gui;

////////////////////////////////////////////////////////////////////////////////////////////////////

#include "mm1gui.h"

#include <gnome.h>

////////////////////////////////////////////////////////////////////////////////////////////////////

#define SIGNAL_MM1_FILE_OPEN			0x21008111
#define SIGNAL_MM1_IMPORT_PDB			0x21008211
#define SIGNAL_MM1_IMPORT_HIN			0x21008212
#define SIGNAL_MM1_FILE_SAVEAS			0x21008112
#define SIGNAL_MM1_FILE_CLOSE			0x21008113

#define SIGNAL_MM1_SETTINGS_ELEMENT		0x2100B050
#define SIGNAL_MM1_SETTINGS_BONDTYPE		0x2100B051

#define SIGNAL_MM1_RMODE_WIREFRAME		0x21009000
#define SIGNAL_MM1_RMODE_BALLANDSTICK		0x21009001
#define SIGNAL_MM1_RMODE_VANDERWAALS		0x21009002
#define SIGNAL_MM1_RMODE_CYLINDERS		0x21009003
#define SIGNAL_MM1_RMODE_NOTHING		0x21009004

#define SIGNAL_MM1_OBJECTS_RIBBON		0x2100A000
#define SIGNAL_MM1_OBJECTS_EPLANE		0x2100A001
#define SIGNAL_MM1_OBJECTS_ESURFACE		0x2100A002
#define SIGNAL_MM1_OBJECTS_VDWSURFACE		0x2100A003

#define SIGNAL_MM1_COMPUTE_ENERGY		0x2100B000
#define SIGNAL_MM1_COMPUTE_GEOMOPT		0x2100B010
#define SIGNAL_MM1_COMPUTE_MOLDYN		0x2100B011

#define SIGNAL_MM1_HYDROGENS			0x2100C000
#define SIGNAL_MM1_BUILDER			0x2100C001

////////////////////////////////////////////////////////////////////////////////////////////////////

class t3_mm1_gui : public mm1_gui
{
	protected:
	
	static GnomeUIInfo file_submenu[];
	static GnomeUIInfo fileimport_submenu[];
	static GnomeUIInfo select_submenu[];
	static GnomeUIInfo settings_submenu[];
	
	static GnomeUIInfo views_submenu[];
	static GnomeUIInfo viewscreate_submenu[];
	static GnomeUIInfo lights_submenu[];
	static GnomeUIInfo rendermode_submenu[];
	static GnomeUIInfo projection_submenu[];
	static GnomeUIInfo render_submenu[];
	
	static GnomeUIInfo objects_submenu[];
	static GnomeUIInfo compute_submenu[];
	
	static GnomeUIInfo popupmenu_info[];
	
	friend class gtkgl_window;
	
	public:
	
	t3_mm1_gui(window_factory &, ostream *);
	~t3_mm1_gui(void);
	
	
	void PopupEvent(view_window *, int);			// virtual
	
	void EnergyReport(mm1_eng *);			// virtual
	bool GeomOptGetParam(mm1_geomopt_param *);	// virtual
	bool MolDynGetParam(mm1_moldyn_param *);	// virtual
};

////////////////////////////////////////////////////////////////////////////////////////////////////

#endif	// T3MM1GUI_H

// eof
