// T3QM2GUI.H : a graphical user interface for qm2-models.

// Copyright (C) 2000 Tommi Hassinen.

// This program is free software; you can redistribute it and/or modify it
// under the terms of the license (GNU GPL) which comes with this package.

////////////////////////////////////////////////////////////////////////////////////////////////////

#include "config.h"	// this is target-dependent...

#ifndef T3QM2GUI_H
#define T3QM2GUI_H

class t3_qm2_gui;

////////////////////////////////////////////////////////////////////////////////////////////////////

#include "qm2gui.h"

#include <gnome.h>

////////////////////////////////////////////////////////////////////////////////////////////////////

#define SIGNAL_QM2_FILE_OPEN			0x12008111
#define SIGNAL_QM2_IMPORT_MM1			0x12008211
#define SIGNAL_QM2_FILE_SAVEAS			0x12008112
#define SIGNAL_QM2_FILE_CLOSE			0x12008113

#define SIGNAL_QM2_SETTINGS_ELEMENT		0x1200B010
#define SIGNAL_QM2_SETTINGS_BONDTYPE		0x1200B011

#define SIGNAL_QM2_RMODE_WIREFRAME		0x12009000
#define SIGNAL_QM2_RMODE_BALLANDSTICK		0x12009001
#define SIGNAL_QM2_RMODE_NOTHING		0x12009004

#define SIGNAL_QM2_OBJECTS_EDPLANE		0x1200A001
#define SIGNAL_QM2_OBJECTS_EDSURFACE		0x1200A002
#define SIGNAL_QM2_OBJECTS_MOPLANE		0x1200A003
#define SIGNAL_QM2_OBJECTS_MOSURFACE		0x1200A004
#define SIGNAL_QM2_OBJECTS_MODPLANE		0x1200A005
#define SIGNAL_QM2_OBJECTS_MODSURFACE		0x1200A006

#define SIGNAL_QM2_COMPUTE_ENERGY		0x1200B000

#define SIGNAL_QM2_SETORBITAL			0x1200C000

////////////////////////////////////////////////////////////////////////////////////////////////////

class t3_qm2_gui : public qm2_gui
{
	protected:
	
	static GnomeUIInfo file_submenu[];
	static GnomeUIInfo fileimport_submenu[];
	static GnomeUIInfo select_submenu[];
	static GnomeUIInfo settings_submenu[];
	
	static GnomeUIInfo views_submenu[];
	static GnomeUIInfo viewscreate_submenu[];
	static GnomeUIInfo lights_submenu[];
	static GnomeUIInfo rendermode_submenu[];
	static GnomeUIInfo projection_submenu[];
	static GnomeUIInfo render_submenu[];
	
	static GnomeUIInfo objects_submenu[];
	static GnomeUIInfo compute_submenu[];
	
	static GnomeUIInfo popupmenu_info[];
	
	friend class gtkgl_window;
	
	public:
	
	t3_qm2_gui(window_factory &, ostream *);
	~t3_qm2_gui(void);
	
	void PopupEvent(view_window *, int);			// virtual
	
	void EnergyReport(qm2_eng *);			// virtual
};

////////////////////////////////////////////////////////////////////////////////////////////////////

#endif	// T3QM2GUI_H

// eof
